// -*-C++-*-
// coordsystem.h (imported from forge/servers/pangea/MapLaw/MapCoordSystem.h)
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

// DESCRIPTION:
// Defines properties of coordinate system
//

#ifndef __COORDSYSTEM_H
#define __COORDSYSTEM_H

#include "coord.h"

class CoalCoordSystem
{
public:
    CoalCoordSystem();
    virtual ~CoalCoordSystem();

public:
    CoalCoordType GetXExtents () { return m_extents.GetX(); }
    CoalCoordType GetYExtents () { return m_extents.GetY(); }
    CoalCoordType GetZExtents () { return m_extents.GetZ(); }
    void GetExtents (CoalCoord &coord) { coord = m_extents; }

    void SetXExtents (CoalCoordType x) { m_extents.SetX(x); }
    void SetYExtents (CoalCoordType y) { m_extents.SetY(y); }
    void SetZExtents (CoalCoordType z) { m_extents.SetZ(z); }
    void SetExtents (CoalCoordType x, CoalCoordType y, CoalCoordType z);

    CoalCoordType GetXGrain () { return m_granularity.GetX(); }
    CoalCoordType GetYGrain () { return m_granularity.GetY(); }
    CoalCoordType GetZGrain () { return m_granularity.GetZ(); }

    void SetXGrain (CoalCoordType x) { m_granularity.SetX(x); }
    void SetYGrain (CoalCoordType y) { m_granularity.SetY(y); }
    void SetZGrain (CoalCoordType z) { m_granularity.SetZ(z); }
    void SetGrain (CoalCoordType x, CoalCoordType y, CoalCoordType z);

    bool IsPointValid(CoalCoord& testPoint);

private:
    CoalCoord m_extents;
    CoalCoord m_granularity;  // Smallest increments

};

#endif  // __COORDSYSTEM_H
