// -*-C++-*-
// debug.h
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#ifndef __DEBUG_H
#define __DEBUG_H

#include "coord.h"
#include "graphic.h"
#include "query.h"
#include "object.h"
#include "database.h"

typedef enum
{
    COAL_DEBUG_FULL,
    COAL_DEBUG_NORMAL,
    COAL_DEBUG_BRIEF,
} CoalDebugVerbosity;

class CoalDebug
{
public:
    CoalDebug () {}
    virtual ~CoalDebug () {}

    static void Dump (const CoalCoord &coord);
    static void Dump (CoalRect &rect);
    static void Dump (const CoalColor &color);
    static void Dump (const CoalGraphic &graphic);
    static void Dump (const CoalPolyGraphic &graphic);
    static void Dump (CoalFill &fill);
    static void Dump (CoalRegion &region);
    static void Dump (CoalShape &shape);
    static void Dump (CoalObject &object);
    static void Dump (const CoalTile &tile);
    static void Dump (CoalQuery &query);
    static void Dump (CoalDatabase &database);

    static void AsciiDump (CoalShape &shape);

#if 0
    // NOTE: const on CoalMap interferes with query
    static void Dump (CoalMap &map, CoalDebugVerbosity verbose = COAL_DEBUG_FULL);
#endif
};

#endif  // __DEBUG_H
